<template>
  <PButton
    v-if="!config"
    :label="t('component.avatar.create')"
    class="AvatarCreator__Create"
    @click="createAvatar"
  />

  <PButton
    v-if="config"
    :label="t('component.avatar.modify')"
    class="AvatarCreator__Modify"
    @click="modify = true"
  />

  <Dialog
    v-if="config"
    v-model:visible="modify"
    class="AvatarCreator"
    dismissable-mask
    :closable="false"
  >
    <template #header>
      <AvatarDisplay :config="config" class="AvatarCreator__Avatar" />

      <PButton
        :label="t('component.avatar.randomize')"
        class="p-button-secondary p-button-outlined"
        icon="mdi mdi-autorenew"
        @click="randomize"
      />
    </template>

    <template #footer>
      <PButton
        :label="t('action.delete')"
        class="p-button-danger p-button-outlined p-button-text"
        icon="mdi mdi-delete-outline"
        @click="deleteAvatar"
      />

      <PButton
        :label="t('action.cancel')"
        class="p-button-secondary p-button-outlined"
        icon="mdi mdi-refresh"
        @click="cancel"
      />

      <PButton
        class="AvatarCreator__Save"
        :disabled="pristine"
        :label="t('action.save')"
        @click="useAsAvatar"
      />
    </template>

    <AvatarBody v-model="config" class="AvatarCreator__Body" />
    <AvatarClothing v-model="config" class="AvatarCreator__Clothing" />
  </Dialog>
</template>

<script lang="ts" setup>
import type { AvatarConfig } from '@/api'
import { AvatarDisplay } from '../index'
import { useI18n } from 'vue-i18n'
import { getRandomAvatar } from '@/components/avatar/getRandomAvatar'
import { injectStrict } from '@/injectStrict'
import { ResourcesKey, SettingsKey } from '@/provided'
import { cloneDeep, isEqual } from 'lodash'
import { computed, ref, watchEffect } from 'vue'
import { avatarClient } from '@/api'
import AvatarClothing from '@/components/avatar/Creator/AvatarClothing.vue'
import AvatarBody from '@/components/avatar/Creator/AvatarBody.vue'
import Dialog from 'primevue/dialog/Dialog.vue'

const { t } = useI18n()

const settings = injectStrict(SettingsKey)
const Resources = injectStrict(ResourcesKey)

const currentAvatar = computed(
  () => Resources.getUserWithAvatar(settings.user.id).value.avatar
)
const config = ref<AvatarConfig | null>(null)

const reload = () => (config.value = cloneDeep(currentAvatar.value))
watchEffect(reload)

const pristine = computed(() => isEqual(config.value, currentAvatar.value))

const modify = ref(false)

/**
 * Replace avatar with a random one
 */
function randomize() {
  config.value = getRandomAvatar()
}

/**
 * Cancel avatar modification
 */
function cancel() {
  modify.value = false
  reload()
}

/**
 * Create and save a random avatar
 */
async function createAvatar() {
  config.value = getRandomAvatar()
  await avatarClient.create(config.value)
  Resources.getUserWithAvatar(settings.user.id, true)
  modify.value = true
}

/**
 * Use displayed avatar for current user
 */
async function useAsAvatar() {
  if (!config.value || !currentAvatar?.value?.id) return
  if (isEqual(config.value, currentAvatar.value)) return

  await avatarClient.patch(currentAvatar.value.id, config.value)
  Resources.getUserWithAvatar(settings.user.id, true)
  modify.value = false
}

/**
 * Delete avatar for current user
 */
async function deleteAvatar() {
  config.value = null
  modify.value = false
  if (currentAvatar.value) await avatarClient.delete(currentAvatar.value.id)
  Resources.getUserWithAvatar(settings.user.id, true)
}
</script>

<style lang="scss" scoped>
@use '../../../style/variables' as v;
@use '../../../style/mixins' as m;

.AvatarCreator {
  &__Create,
  &__Modify {
    margin: v.$spacing 0;
  }

  &__Avatar {
    width: 8rem;
    height: 8rem;
    border: 1px solid var(--surface-600);
  }
}
</style>
